/* Form definition file generated with fdesign. */

#include "forms.h"
#include "xchooser.h"

extern char cfilename[];  
extern char * lines[1024];
extern int items;

void fill_choices(FL_OBJECT *obj)
{
  FILE * xchf;
  char cline[1024];
  int i;

  xchf=fopen(cfilename,"r");
  if (xchf==NULL)
    {
      fprintf(stderr, "Choice file not found\n");
      return;
    }

  while (!feof(xchf))
    {
      fgets(cline,1024,xchf);
      if (feof(xchf)) break;
      for (i=0;i<1024;i++) if (cline[i]<' ') cline[i]=0;
      fl_add_browser_line(obj,cline);
      lines[items]=(char *)calloc(1, strlen(cline)+1);
      strcpy(lines[items],cline);
      items++;
    }
  fclose(xchf);
}   
update_file(char * inputline)
{
  FILE * xchf;
  int i;
  int in_line=0;
  xchf=fopen(cfilename,"w");
  if (xchf==NULL)
    {
      fprintf(stderr, "Can't update choice file\n");
      return;
    }

  for (i=0;i<items;i++)
    {
      if (strcmp(lines[i],inputline)==0) in_line=1;
      fprintf(xchf,"%s\n",lines[i]);
    }
  
  if (!in_line && (strlen(inputline)!=0))
    fprintf(xchf,"%s\n",inputline);
  fclose(xchf);
}
FD_xchooser *create_form_xchooser(void)
{
  FL_OBJECT *obj;
  FD_xchooser *fdui = (FD_xchooser *) fl_calloc(1, sizeof(*fdui));

  fdui->xchooser = fl_bgn_form(FL_NO_BOX, 320, 230);
  obj = fl_add_box(FL_FLAT_BOX,0,0,320,230,"");
  fdui->browser = obj = fl_add_browser(FL_SELECT_BROWSER,10,10,300,122,"");
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE);
    fl_set_object_callback(obj,selected,0);
    fl_set_browser_fontsize(obj,FL_MEDIUM_SIZE);
    fl_set_browser_specialkey(obj,1);
    fill_choices(obj);
  fdui->input = obj = fl_add_input(FL_NORMAL_INPUT,10,150,300,30,"");
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_callback(obj,typed,0);
  fdui->ok_button = obj = fl_add_button(FL_NORMAL_BUTTON,10,190,80,30,"Ok");
    fl_set_button_shortcut(obj,"^M^J^K",1);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE);
    fl_set_object_callback(obj,ok_callback,0);
  fdui->cancel_button = obj = fl_add_button(FL_NORMAL_BUTTON,230,190,80,30,
					    "Cancel");
    fl_set_button_shortcut(obj,"^[^C",1);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE);
    fl_set_object_callback(obj,cancel_callback,0);
  fdui->remove_button = obj = fl_add_button(FL_NORMAL_BUTTON,120,190,80,30,
					    "Remove");
    fl_set_button_shortcut(obj,"^R",1);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE);
    fl_set_object_callback(obj,remove_callback,0);
  fl_end_form();

  return fdui;
}


